This was created by checking out qtdoc and checking out the kf5
patches from kde.  For more details of those, see
https://dot.kde.org/2021/04/06/announcing-kdes-qt-5-patch-collection

 from kde:
 git clone https://invent.kde.org/qt/qt/qtdoc
 cd qtdoc
 git checkout -t origin/5.15
 git format-patch origin/5.15.2..origin/kde/5.15

To update for new patches, git pull and then rerun git format-patch.

Last updated: 2021-01-25

 Following patches commented:
 patch 01 would change the version to 5.15.3
 patch 04 already applied
 patch 06 already applied
 patch 08 already applied
 patch 09 already applied

In addition, patch 15 failed to apply (the Xcode line in 5.15.2
differed from what is in kf5.15).  I fixed it up manually, but
no idea why that line differed.

#From 1f315f579d5a81860a3d1e0f79cabf649086172d Mon Sep 17 00:00:00 2001
#From: Jani Heikkinen <jani.heikkinen@qt.io>
#Date: Tue, 27 Oct 2020 07:48:41 +0200
#Subject: [PATCH 01/15] Bump version
#
#Change-Id: I236142dfc8c7c108d2e9b7ca5736a8670017006d
#---
# .qmake.conf | 2 +-
# 1 file changed, 1 insertion(+), 1 deletion(-)
#
#diff --git a/.qmake.conf b/.qmake.conf
#index b16fbc32..2b92eda5 100644
#--- a/.qmake.conf
#+++ b/.qmake.conf
#@@ -1,3 +1,3 @@
# load(qt_build_config)
# 
#-MODULE_VERSION = 5.15.2
#+MODULE_VERSION = 5.15.3
#-- 
#2.33.0
#
From f054fa1c1bff180a53b0124c1bf687b0423100ef Mon Sep 17 00:00:00 2001
From: Volker Hilsheimer <volker.hilsheimer@qt.io>
Date: Tue, 27 Oct 2020 15:27:50 +0100
Subject: [PATCH 02/15] EGLFS: document that desktop-centric APIs are not
 supported

Task-number: QTBUG-87765
Change-Id: I8278df7250124cc1a360d4a27696ffe16aaeef61
Reviewed-by: Laszlo Agocs <laszlo.agocs@qt.io>
(cherry picked from commit 5209f5265033e5f7be3c48b13b94650113c09c5b)
Reviewed-by: Volker Hilsheimer <volker.hilsheimer@qt.io>
---
 doc/src/platforms/emb-linux.qdoc | 3 +++
 1 file changed, 3 insertions(+)

diff --git a/doc/src/platforms/emb-linux.qdoc b/doc/src/platforms/emb-linux.qdoc
index faa4fd4f..a3dbc6b0 100644
--- a/doc/src/platforms/emb-linux.qdoc
+++ b/doc/src/platforms/emb-linux.qdoc
@@ -89,6 +89,9 @@
   such windows with QWidget-based content isn't supported; Qt terminates the
   application with an error message.
 
+  Furthermore, APIs designed for desktop platforms or environments with a
+  windowing system, such as \l{Drag and Drop}, are not supported on EGLFS.
+
   If necessary, \c eglfs can be configured using the following environment
   variables:
 
-- 
2.33.0

From 66bc586f96cf815274772aa96596953842aee2a1 Mon Sep 17 00:00:00 2001
From: Kai Koehne <kai.koehne@qt.io>
Date: Wed, 28 Oct 2020 08:49:07 +0100
Subject: [PATCH 03/15] Move Qt Wayland Compositor to Commercial/GPLv3 section

Task-number: QTBUG-87959
Change-Id: I6dc228b35daecad547acb492b94c1c8a102c2bf7
Reviewed-by: Paul Wicking <paul.wicking@qt.io>
(cherry picked from commit 9b7c29a44b23d2ea01091830e277e3941ac48af9)
---
 doc/src/qtmodules.qdoc | 10 +++++-----
 1 file changed, 5 insertions(+), 5 deletions(-)

diff --git a/doc/src/qtmodules.qdoc b/doc/src/qtmodules.qdoc
index cde3a58f..5fa5c4f1 100644
--- a/doc/src/qtmodules.qdoc
+++ b/doc/src/qtmodules.qdoc
@@ -362,11 +362,6 @@
         \li All
         \li All
         \li Support for XPath, XQuery, XSLT and XML schema validation.
-    \row
-        \li \l{Qt Wayland Compositor}
-        \li \l{Qt for Linux/X11}{Linux}
-        \li \l{Qt for Linux/X11}{Linux} and \l{Boot2Qt}{Boot to Qt} targets.
-        \li Provides a framework to develop a Wayland compositor.
     \row
     \header
         \li {4,1} \target gpl-licensed-addons
@@ -402,6 +397,11 @@
         \li A framework for implementing different input methods as
             well as a QML virtual keyboard. Supports localized keyboard
             layouts and custom visual themes.
+    \row
+        \li \l{Qt Wayland Compositor}
+        \li \l{Qt for Linux/X11}{Linux}
+        \li \l{Qt for Linux/X11}{Linux} and \l{Boot2Qt}{Boot to Qt} targets.
+        \li Provides a framework to develop a Wayland compositor.
     \row
         \li \l{Qt for WebAssembly}
         \li All
-- 
2.33.0

#From e5371451a35f590c1121c13a910ec3329c570601 Mon Sep 17 00:00:00 2001
#From: Antti Kokko <antti.kokko@qt.io>
#Date: Tue, 27 Oct 2020 10:02:11 +0200
#Subject: [PATCH 04/15] Add changes file for Qt 5.15.2
#
#- d090008ce51f995c87b7a5cd9f7cf47dda1865b3 Add changes file for Qt 5.15.1
#+ 6ab3f6199bd74726143efa0db4a697d7d9fda460 Android: update docs, and remove few duplicates
#- 5313fada1d847bd4c4872ed338cadab46189cc4a Document Third-Party Code changes in 5.15.1
#- b452310a1366f3422d6a7cf98d3b85562218759a Restore macOS supported platforms documentation
#+ 684cf652c8b0e58ec33125197cf0918091ceb097 Tweak CMake "hello world"
#+ 7e47a90ba78972c1d85eed28563206ca0f34a40b Remove 'Open Source Licensing of Qt' page
#+ 433c92b655a62609e06c109ab0ecaeb73ab152d9 Doc: fix dead links
#+ e3333439a4ebd6a765bb148d94319138610b7535 Update QDoc source code location
#+ 2e1697578072216795d1a3642c7bfbcb0a381fbc Bump version
#+ dbec3ef48a1bb5ba17c4a2ddc486fbd23b3ab006 Add changes file for Qt 5.12.10
#+ 85d3a019f854d16c07e5d3cac1c617aa50626bba Android: update android building and getting started pages
#
#Change-Id: I691087f7528039a4e4e92b8ad0bd452b14c1948d
#Reviewed-by: Paul Wicking <paul.wicking@qt.io>
#(cherry picked from commit ca96e917bd3712e359dc6953d37e2f751079ee04)
#Reviewed-by: Qt Cherry-pick Bot <cherrypick_bot@qt-project.org>
#---
# dist/changes-5.15.2 | 38 ++++++++++++++++++++++++++++++++++++++
# 1 file changed, 38 insertions(+)
# create mode 100644 dist/changes-5.15.2
#
#diff --git a/dist/changes-5.15.2 b/dist/changes-5.15.2
#new file mode 100644
#index 00000000..d4df5f8b
#--- /dev/null
#+++ b/dist/changes-5.15.2
#@@ -0,0 +1,38 @@
#+Qt 5.15.2 is a bug-fix release. It maintains both forward and backward
#+compatibility (source and binary) with Qt 5.15.1.
#+
#+For more details, refer to the online documentation included in this
#+distribution. The documentation is also available online:
#+
#+  https://doc.qt.io/qt-5.15/index.html
#+
#+The Qt version 5.15 series is binary compatible with the 5.14.x series.
#+Applications compiled for 5.14 will continue to run with 5.15.
#+
#+Some of the changes listed in this file include issue tracking numbers
#+corresponding to tasks in the Qt Bug Tracker:
#+
#+  https://bugreports.qt.io/
#+
#+Each of these identifiers can be entered in the bug tracker to obtain more
#+information about a particular change.
#+
#+****************************************************************************
#+*                   Important Behavior Changes                             *
#+****************************************************************************
#+
#+****************************************************************************
#+*                          Library                                         *
#+****************************************************************************
#+
#+ - [QTBUG-87070] Android: update android building and getting started pages
#+   Better organize few sections and provide updated commands for
#+   building for Linux and Windows. Also, remove/update few links and
#+   phrases and examples list.
#+   The bug was: Document running and building Qt with CMake
#+ - [QTBUG-84935] Document Third-Party Code changes in 5.15.1
#+   The changes where obtained by running qtattributionsscanner
#+   -output-format json in the sources of both Qt 5.15.0 and Qt 5.15.1
#+   checkouts, and diff'ing these.
#+   The bug was: Document Third-Party Code changes in the release
#+
#-- 
#2.33.0
#
From 902b417ce9e2749f83df2d6edebae1f694497003 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Morten=20Johan=20S=C3=B8rvig?= <morten.sorvig@qt.io>
Date: Fri, 30 Oct 2020 13:49:25 +0100
Subject: [PATCH 05/15] wasm: link to platform notes page instead of wiki
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

These have more-or-less the same content.

Change-Id: Ia7eafe2dc3a0d1d5041a10b14c492c7d3f1a2ab9
Reviewed-by: Tor Arne Vestbø <tor.arne.vestbo@qt.io>
---
 doc/src/platforms/webasm.qdoc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/doc/src/platforms/webasm.qdoc b/doc/src/platforms/webasm.qdoc
index ce8b9c68..862417e2 100644
--- a/doc/src/platforms/webasm.qdoc
+++ b/doc/src/platforms/webasm.qdoc
@@ -176,7 +176,7 @@ You can test-run your application in the following way:
 The most important limitation is that the Qt build is static,
 and does not support threads.
 
-For further info, refer to \l { https://wiki.qt.io/Qt_for_WebAssembly#Known_issues_and_platform_notes}{Known_issues_and_platform_notes}.
+For further info, refer to \l{qtwebassembly-platform-notes}
 
 \section1 External resources
 
-- 
2.33.0

#From 8df69cb2b52eeea749c573316fc1deb4b0277408 Mon Sep 17 00:00:00 2001
#From: =?UTF-8?q?Morten=20Johan=20S=C3=B8rvig?= <morten.sorvig@qt.io>
#Date: Fri, 30 Oct 2020 13:50:30 +0100
#Subject: [PATCH 06/15] wasm: move supported modules list to front page
#MIME-Version: 1.0
#Content-Type: text/plain; charset=UTF-8
#Content-Transfer-Encoding: 8bit
#
#Let’s give this a little more visibility.
#
#Change-Id: Id3fa30265e3455845daa6cabc8153b96eb7f3d72
#Reviewed-by: Tor Arne Vestbø <tor.arne.vestbo@qt.io>
#---
# .../qtwebassembly-platform-notes.qdoc         | 13 -----------
# doc/src/platforms/webasm.qdoc                 | 23 +++++++++++++++++++
# 2 files changed, 23 insertions(+), 13 deletions(-)
#
#diff --git a/doc/src/platforms/qtwebassembly-platform-notes.qdoc b/doc/src/platforms/qtwebassembly-platform-notes.qdoc
#index 9b5fa0d6..785c3ff0 100644
#--- a/doc/src/platforms/qtwebassembly-platform-notes.qdoc
#+++ b/doc/src/platforms/qtwebassembly-platform-notes.qdoc
#@@ -72,19 +72,6 @@
#     does use some operating system adaptations, for example for ctrl/cmd
#     key handling on macOS.
# 
#-    \section2 Supported Qt Modules
#-
#-    Qt for WebAssembly supports a subset of the Qt modules. The list below
#-    lists the currently tested modules. The list can be pasted as arguments
#-    to \c make.
#-
#-    \badcode
#-        module-qtbase module-qtdeclarative module-qtquickcontrols2 module-qtwebsockets module-qtsvg module-qtcharts module-qtmqtt
#-    \endcode
#-
#-    Other modules are untested and may work.  Are not supported: QtMultimedia
#-    and QtWebView
#-
#     \section3 Known issues
# 
#     Refer to the \l{https://wiki.qt.io/Qt_for_WebAssembly#Known issues}{wiki}.
#diff --git a/doc/src/platforms/webasm.qdoc b/doc/src/platforms/webasm.qdoc
#index 862417e2..918d2c23 100644
#--- a/doc/src/platforms/webasm.qdoc
#+++ b/doc/src/platforms/webasm.qdoc
#@@ -88,6 +88,29 @@ After installation, you should have emscripten in your path.  Check this with th
# The binary builds can be downloaded in the Downloads section using your Qt
# account.
# 
#+\section3 Supported Qt modules
#+
#+The following modules are supported by Qt for WebAssembly:
#+
#+\list
#+    \li QtBase
#+    \li QtDeclarative
#+    \li QtQuickcontrols2
#+    \li QtWebsockets
#+    \li QtSvg
#+    \li QtCharts
#+    \li QtMqtt
#+\endlist
#+
#+The following modules do not work:
#+
#+\list
#+    \li QtMultimedia
#+    \li QtWebView
#+\endlist
#+
#+Other modules may work, but are not supported.
#+
# \section3 Build Qt from the sources
# 
# Alternatively, you could download the Qt sources in the Downloads section,
#-- 
#2.33.0
#
From b75fd7175fc13c7354c9d232bd3812feab8d2ff9 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Morten=20Johan=20S=C3=B8rvig?= <morten.sorvig@qt.io>
Date: Fri, 30 Oct 2020 14:04:29 +0100
Subject: [PATCH 07/15] wasm: remove some incorrect information

Thread support is off by default, but can be enabled
with -feature-thread.

Change-Id: I433534389f6c3cba2407db471491af29a1e19465
Reviewed-by: Paul Wicking <paul.wicking@qt.io>
---
 doc/src/platforms/webasm.qdoc | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

diff --git a/doc/src/platforms/webasm.qdoc b/doc/src/platforms/webasm.qdoc
index 918d2c23..586d35de 100644
--- a/doc/src/platforms/webasm.qdoc
+++ b/doc/src/platforms/webasm.qdoc
@@ -137,7 +137,8 @@ Build required modules:
     make module-qtbase module-qtdeclarative [other modules]
 \endcode
 
-The Qt build is a static build, and does not support threads.
+The Qt build is a static build, and does not support threads by default. Configure with  \c{-feature-thread}
+to enable thread support.
 
 \section3 Build and run your application
 
@@ -196,8 +197,7 @@ You can test-run your application in the following way:
 
 \section1 Limitations
 
-The most important limitation is that the Qt build is static,
-and does not support threads.
+The most important limitation is that the Qt build is static.
 
 For further info, refer to \l{qtwebassembly-platform-notes}
 
-- 
2.33.0

#From 3c394507e172e7744275dc049c430966febe56d7 Mon Sep 17 00:00:00 2001
#From: Jani Heikkinen <jani.heikkinen@qt.io>
#Date: Mon, 2 Nov 2020 12:37:40 +0200
#Subject: [PATCH 08/15] Document Third-Party Code changes in 5.15.2
#
#The changes where obtained by running
#
#  qtattributionsscanner -output-format json
#
#in the sources of both Qt 5.15.1 and Qt 5.15.2 checkouts, and diff'ing
#these.
#
#Task-number: QTBUG-86908
#Change-Id: I3ccec8d26a8889be372ff245de45d6e87c56e75d
#Reviewed-by: Kai Koehne <kai.koehne@qt.io>
#(cherry picked from commit 7afacb76c81cee87aef9f539f55b8964bd550945)
#Reviewed-by: Qt Cherry-pick Bot <cherrypick_bot@qt-project.org>
#---
# doc/src/legal/licensechanges.qdoc | 23 +++++++++++++++++++++++
# 1 file changed, 23 insertions(+)
#
#diff --git a/doc/src/legal/licensechanges.qdoc b/doc/src/legal/licensechanges.qdoc
#index 0d65cb07..b94e3891 100644
#--- a/doc/src/legal/licensechanges.qdoc
#+++ b/doc/src/legal/licensechanges.qdoc
#@@ -35,6 +35,29 @@
#     released with Qt that are relevant to licensing.
# 
# 
#+    \section1 Qt 5.15.2
#+
#+    \section2 Qt 3D Module
#+    \list
#+        \li Use of \l{Assimp - Clipper} under the \e{Boost Software License 1.0} is now documented.
#+        \li Use of \l{Assimp - irrXML} under the \e{zlib License} is now documented.
#+        \li Use of \l{Assimp - Open3DGC} under the \e{MIT License and BSD 2-Clause \"Simplified\" License} is now documented.
#+        \li Use of \l{Assimp - The OpenDDL-Parser} under the \e{MIT License} is now documented.
#+        \li Use of \l{Assimp - Poly2Tri Polygon Triangulation Library} under the \e{BSD 3-clause \"New\" or \"Revised\" License} is now documented.
#+        \li Use of \l{Assimp - RapidJSON} under the \e{MIT License and BSD 3-Clause \"New\" or \"Revised\" License} is now documented.
#+        \li Use of \l{Assimp - Unzip} under the \e{zlib License} is now documented.
#+        \li Use of \l{Assimp - Utf8Cpp} under the \e{Boost Software License 1.0} is now documented.
#+        \li Use of \l{Assimp - Zip} under the \e{Public Domain License} is now documented.
#+        \li Use of \l{Dear ImGui - ProggyClean.ttf} under the \e{MIT License or Public Domain} is now documented.
#+        \li Use of \l{Dear ImGui - stb} under the \e{MIT License} is now documented.
#+    \endlist
#+
#+    \section2 Qt SQL Module
#+    \l{sqlite}{SQLite} got updated to upstream version 3.30.0.
#+
#+    \section2 Qt GUI Module
#+    \l{Wintab API} license updated to \e{LCS-Telegraphics License}
#+
#     \section1 Qt 5.15.1
# 
#     \section2 Qt Core Module
#-- 
#2.33.0
#
#From 8dba71ff1a2614e6e01fdcb82fb74dbf013c725b Mon Sep 17 00:00:00 2001
#From: =?UTF-8?q?Tor=20Arne=20Vestb=C3=B8?= <tor.arne.vestbo@qt.io>
#Date: Tue, 10 Nov 2020 12:16:31 +0100
#Subject: [PATCH 09/15] Clarify that the CI does not define the reference
# configurations
#
#For various reasons, not all reference configurations are tested in
#the CI, but may instead be tested day to day by developers, and manually
#as part of the release process.
#
#By removing the CI references in the documentation we make it clear
#that the CI does not define the list of reference configurations.
#
#Change-Id: Ie16dd23afe5cae9d0a67a216cd113ab3c3ca10ec
#Reviewed-by: Heikki Halmet <heikki.halmet@qt.io>
#(cherry picked from commit ce554b6313bac4b760bbced03b113d8cb4803ce3)
#Reviewed-by: Qt Cherry-pick Bot <cherrypick_bot@qt-project.org>
#---
# doc/src/platforms/supported-platforms.qdoc | 17 ++++++-----------
# 1 file changed, 6 insertions(+), 11 deletions(-)
#
#diff --git a/doc/src/platforms/supported-platforms.qdoc b/doc/src/platforms/supported-platforms.qdoc
#index 1090f0e8..dda1fda1 100644
#--- a/doc/src/platforms/supported-platforms.qdoc
#+++ b/doc/src/platforms/supported-platforms.qdoc
#@@ -65,13 +65,12 @@
# 
#     \section1 Reference Configurations
# 
#-    The reference configurations are run on the continuous integration (CI)
#-    system within Qt Project. In addition, they are subjected to unit test suite
#-    and other internal testing tools on a frequent basis (prior to new version
#-    releases, source tree branching, and at other significant period points in
#-    the development process). Errors or bugs discovered in these platforms are
#-    prioritized for correction. Significant errors discovered in tested
#-    configurations can impact release dates.
#+    Reference configurations are the primary focus of development. They are subjected
#+    to unit test suite and other internal testing tools on a frequent basis (prior to
#+    new version releases, source tree branching, and at other significant period points
#+    in the development process). Errors or bugs discovered in these platforms are
#+    prioritized for correction. Significant errors discovered in tested configurations
#+    can impact release dates.
# 
#     Any configurations not listed above are not actively tested by the Qt
#     Project. However, Qt may run on configurations other than those actively
#@@ -80,10 +79,6 @@
#     state for that particular configuration. The reference configurations are
#     subject to change during the lifetime of a Qt release.
# 
#-    Details of the reference configurations are stored as \e {provisioning scripts}
#-    in the \l {https://code.qt.io/cgit/qt/qt5.git/tree/coin?h=\qtver}
#-    {qt5 Git repository}.
#-
#     The Qt Company provides support for the officially supported platforms and
#     configurations. The Qt Company, Qt partners, open source projects and community
#     users are also able to provide assistance with various different platforms and
#-- 
#2.33.0
#
From 90ccf92b66b7629a856a45a28947d0cb1699a386 Mon Sep 17 00:00:00 2001
From: Assam Boudjelthia <assam.boudjelthia@qt.io>
Date: Thu, 12 Nov 2020 13:28:25 +0200
Subject: [PATCH 10/15] Android: keep only mandatory arguments for configure
 when building

Remove optional arguments when building from source, since there is a
link for additional arguments in the page.

Change-Id: I418182776e59f3d4fc8422977c2138afe93c6922
Reviewed-by: Alexandru Croitor <alexandru.croitor@qt.io>
---
 doc/src/platforms/android/android-building.qdoc | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

diff --git a/doc/src/platforms/android/android-building.qdoc b/doc/src/platforms/android/android-building.qdoc
index 8b88efa4..be51b8e5 100644
--- a/doc/src/platforms/android/android-building.qdoc
+++ b/doc/src/platforms/android/android-building.qdoc
@@ -120,7 +120,7 @@
     mkdir <path_to_build_dir>/build-qt
     cd <path_to_build_dir>/build-qt
 
-    <path_to_qt_source>/configure -xplatform android-clang -prefix </path/to/install> -disable-rpath -nomake tests -nomake examples -android-ndk <path/to/sdk>/ndk/<ndk_version> -android-sdk <path/to/sdk> -no-warnings-are-errors
+    <path_to_qt_source>/configure -xplatform android-clang -prefix </path/to/install> -android-ndk <path/to/sdk>/ndk/<ndk_version> -android-sdk <path/to/sdk>
     \endcode
 
     \l{Qt Configure Options} contains more information about the configure options.
@@ -219,7 +219,7 @@
     mkdir C:\Qt\Build\build-qt
     cd C:\Qt\Build\build-qt
 
-    ..\Src_%VERSION%\configure.bat -platform win32-g++ -xplatform android-clang -prefix <\path\to\install> -nomake tests -nomake examples -android-sdk <ANDROID_SDK_PATH> -android-ndk <ANDROID_SDK_PATH>\ndk\<ndk_version> -android-ndk-host windows-x86_64 -no-warnings-are-errors
+    ..\Src_%VERSION%\configure.bat -platform win32-g++ -xplatform android-clang -prefix <\path\to\install> -android-sdk <ANDROID_SDK_PATH> -android-ndk <ANDROID_SDK_PATH>\ndk\<ndk_version> -android-ndk-host windows-x86_64
     \endcode
 
     \l{Qt Configure Options} contains more information about the configure options.
-- 
2.33.0

From cbd1102e2649dfbe280f3b0d26a62278a8031540 Mon Sep 17 00:00:00 2001
From: Liang Qi <liang.qi@qt.io>
Date: Mon, 16 Nov 2020 14:56:50 +0100
Subject: [PATCH 11/15] Doc: update some packages for Linux
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

Fixes: QTBUG-88409
Change-Id: Ifce6dcd3a3ef7263f06309586ce688921a9ff7d7
Reviewed-by: Tor Arne Vestbø <tor.arne.vestbo@qt.io>
(cherry picked from commit 05bd1e8a443e9e6608a42be62b9d5b4b502a930b)
Reviewed-by: Qt Cherry-pick Bot <cherrypick_bot@qt-project.org>
---
 doc/src/platforms/linux.qdoc | 32 +++++++++++++++++++++++---------
 1 file changed, 23 insertions(+), 9 deletions(-)

diff --git a/doc/src/platforms/linux.qdoc b/doc/src/platforms/linux.qdoc
index d15abf51..73655aa2 100644
--- a/doc/src/platforms/linux.qdoc
+++ b/doc/src/platforms/linux.qdoc
@@ -149,43 +149,49 @@
     \li libxcb-render
     \li X C Bindings for Render extension
     \li auto-detected
-    \li 1.9
+    \li 1.11
     \row {id="OptionalColor"}
     \li xcb-render-util
     \li libxcb-render-util
     \li Utility library for XCB for Render extension
     \li auto-detected
-    \li 0.3.8
+    \li 0.3.9
     \row {id="OptionalColor"}
     \li xcb-shape
     \li libxcb-shape
     \li X C Bindings for Shape extension
     \li auto-detected
-    \li 1.9
+    \li 1.11
     \row {id="DefaultColor"}
     \li xcb-randr
     \li libxcb-randr
     \li X C Bindings for Resize and Rotate Extension
     \li auto-detected
-    \li 1.9
+    \li 1.11
     \row {id="DefaultColor"}
     \li xcb-xfixes
     \li libxcb-xfixes
     \li X C Bindings for Fixes Extension
     \li auto-detected
-    \li 1.9
+    \li 1.11
+    \row {id="DefaultColor"}
+    \li xcb-xkb
+    \li libxcb-xkb
+    \li X C Bindings for XKeyboard Extension
+    \li auto-detected
+    \li 1.11
     \row {id="DefaultColor"}
     \li xcb-sync
     \li libxcb-sync
     \li X C Bindings for Sync Extension
     \li auto-detected
-    \li 1.9
+    \li 1.11
     \row {id="DefaultColor"}
     \li xcb-shm
     \li libxcb-shm
     \li X C Bindings for Shared Memory Extension
     \li auto-detected
-    \li 1.9
+    \li 1.11
     \row {id="DefaultColor"}
     \li xcb-icccm
     \li libxcb-icccm
@@ -204,6 +210,12 @@
     \li Utility library for XCB for XImage and XShmImage, used for QBackingStore and cursor support
     \li auto-detected
     \li 0.3.9
+    \row {id="DefaultColor"}
+    \li xcb-util
+    \li libxcb-util
+    \li Utility library for XCB for atom, aux and event
+    \li auto-detected
+    \li 0.3.9
 
     \row {id="OptionalColor"}
     \li xkbcommon
@@ -247,7 +259,7 @@
     \li libxcb
     \li X C Binding library
     \li
-    \li 1.9
+    \li 1.11
     \row {id="DefaultColor"}
     \li X11-xcb
     \li libX11-xcb
@@ -302,12 +314,14 @@
     \li libxcb-image0-dev
     \li libxcb-shm0-dev
     \li libxcb-icccm4-dev
-    \li libxcb-sync0-dev
+    \li libxcb-sync-dev
     \li libxcb-xfixes0-dev
     \li libxcb-shape0-dev
     \li libxcb-randr0-dev
     \li libxcb-render-util0-dev
+    \li libxcb-util-dev
     \li libxcd-xinerama-dev
+    \li libxcd-xkb-dev
     \li libxkbcommon-dev
     \li libxkbcommon-x11-dev
     \endlist
-- 
2.33.0

From df6e664c19c858a35efed8641b0b0338cbf9f58d Mon Sep 17 00:00:00 2001
From: Assam Boudjelthia <assam.boudjelthia@qt.io>
Date: Wed, 2 Dec 2020 23:05:40 +0200
Subject: [PATCH 12/15] Android: update linux package dependencies

The 32bit packages are not needed by the current SDK tools, and
libncurses is required for gdb to work properly.

Task-number: QTCREATORBUG-24995
Change-Id: I5f1faa3114d5e73cf569a141a61adc048f913b03
Reviewed-by: Andy Shaw <andy.shaw@qt.io>
Reviewed-by: Paul Wicking <paul.wicking@qt.io>
(cherry picked from commit 0a7e3dee8654bab22139c0bbe5b9a65571e30379)
Reviewed-by: Qt Cherry-pick Bot <cherrypick_bot@qt-project.org>
---
 doc/src/platforms/android/android.qdoc | 11 +++++------
 1 file changed, 5 insertions(+), 6 deletions(-)

diff --git a/doc/src/platforms/android/android.qdoc b/doc/src/platforms/android/android.qdoc
index 13a7ab20..2710c3d6 100644
--- a/doc/src/platforms/android/android.qdoc
+++ b/doc/src/platforms/android/android.qdoc
@@ -203,21 +203,20 @@ After the package installation is complete, install the driver from
 \l{Android: adb}{adb} commands now and check whether your Android device
 responds to them.
 
-\section2 Linux 64-bit
+\section2 Linux
 
-If you're developing on a 64-bit Linux machine, you must install the
-following dependencies in order to run 32-bit executables like \c adb, which
-allows Qt Creator to find devices to deploy to:
+The following dependencies are needed for using tools such as \c adb or \c gdb which
+can be used by Qt Creator:
 
 \badcode
-sudo apt-get install libstdc++6:i386 libgcc1:i386 zlib1g:i386 libncurses5:i386
+sudo apt-get install libstdc++6 libncurses5
 \endcode
 
 \target emulator dependencies
 To run the Android emulator, the following dependencies are also necessary:
 
 \badcode
-sudo apt-get install libsdl1.2debian:i386
+sudo apt-get install libsdl1.2debian
 \endcode
 
 \section2 Qt Creator IDE
-- 
2.33.0

From 941026dea535f0cb29ef39f50430311080baa045 Mon Sep 17 00:00:00 2001
From: Assam Boudjelthia <assam.boudjelthia@qt.io>
Date: Wed, 2 Dec 2020 23:22:09 +0200
Subject: [PATCH 13/15] Remove unneeded italic decoration

Change-Id: I27637bffa7e316ee049e16776509ce45b454f200
Reviewed-by: Paul Wicking <paul.wicking@qt.io>
(cherry picked from commit a511a458c718b3a110bde3be80c0f8da563415bc)
Reviewed-by: Qt Cherry-pick Bot <cherrypick_bot@qt-project.org>
---
 doc/src/platforms/android/android.qdoc | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

diff --git a/doc/src/platforms/android/android.qdoc b/doc/src/platforms/android/android.qdoc
index 2710c3d6..9163d71f 100644
--- a/doc/src/platforms/android/android.qdoc
+++ b/doc/src/platforms/android/android.qdoc
@@ -146,16 +146,16 @@ Different Qt versions depend on different NDK versions, as listed below:
             Qt 5.13.2 or later
             Qt 5.12.6 or later
         \li NDK r20b or r21
-        \li \e android-clang
+        \li android-clang
     \row
         \li Qt 5.12.0 to 5.12.5
             Qt 5.13.0 to 5.13.1
         \li NDK r19c
-        \li \e android-clang
+        \li android-clang
     \row
         \li Qt 5.11 and earlier
         \li NDK r10e
-        \li \e GCC toolchain
+        \li GCC toolchain
 \endtable
 
 \li \note Qt 5.14.0 and 5.14.1 with NDK r21 have a bug fixed at \l {QTBUG-81461}.
-- 
2.33.0

From ca278111a501c2fc7304b29ec8912858b4f39c0f Mon Sep 17 00:00:00 2001
From: Andre Hartmann <aha_1980@gmx.de>
Date: Sat, 5 Dec 2020 22:55:40 +0100
Subject: [PATCH 14/15] Linux: Fix library xcb spelling errors

The basename is "xcb", not "xcd".
Also, xinerama has a "0" appended.

Change-Id: I7874295445b96b55b0e995d67e8cbe591c309907
Reviewed-by: Paul Wicking <paul.wicking@qt.io>
(cherry picked from commit 128e08d1e9c1e8627e113d0f9a6c2c71f28cc862)
Reviewed-by: Qt Cherry-pick Bot <cherrypick_bot@qt-project.org>
---
 doc/src/platforms/linux.qdoc | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

diff --git a/doc/src/platforms/linux.qdoc b/doc/src/platforms/linux.qdoc
index 73655aa2..88d4b040 100644
--- a/doc/src/platforms/linux.qdoc
+++ b/doc/src/platforms/linux.qdoc
@@ -320,8 +320,8 @@
     \li libxcb-randr0-dev
     \li libxcb-render-util0-dev
     \li libxcb-util-dev
-    \li libxcd-xinerama-dev
-    \li libxcd-xkb-dev
+    \li libxcb-xinerama0-dev
+    \li libxcb-xkb-dev
     \li libxkbcommon-dev
     \li libxkbcommon-x11-dev
     \endlist
-- 
2.33.0

From 897e90fe304d844beaf694b82a93a50237fa8b9e Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Tor=20Arne=20Vestb=C3=B8?= <tor.arne.vestbo@qt.io>
Date: Wed, 9 Dec 2020 13:40:43 +0100
Subject: [PATCH 15/15] Update supported Apple platforms
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

Change-Id: Id8f684150a40be9a2440ecd41ddd84e1fd3fa10d
Reviewed-by: Timur Pocheptsov <timur.pocheptsov@qt.io>
Reviewed-by: Alexandru Croitor <alexandru.croitor@qt.io>
Reviewed-by: Morten Johan Sørvig <morten.sorvig@qt.io>
---
 doc/src/platforms/supported-platforms.qdocinc | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

ken: applied manually, rediffed - the Xcode line in 5.15.2 differed!

diff -Naur a/doc/src/platforms/supported-platforms.qdocinc b/doc/src/platforms/supported-platforms.qdocinc
--- a/doc/src/platforms/supported-platforms.qdocinc	2020-11-06 11:56:42.000000000 +0000
+++ b/doc/src/platforms/supported-platforms.qdocinc	2021-12-22 02:43:10.903034903 +0000
@@ -62,9 +62,9 @@
 //! [macos]
 \table 80%
     \header \li Target Platform \li Architecture \li Build Environment
-    \row \li \macos 10.13, 10.14, \b 10.15
+    \row \li \macos 10.13, 10.14, \b 10.15, 11.0
         \li \c x86_64 and \c x86_64h
-        \li Xcode 11 or \b 12 (10.15 SDK)
+        \li Xcode \b{11 (10.15 SDK)}, 12 (11.0 SDK)
 \endtable
 //! [macos]
 
@@ -108,9 +108,9 @@
 //! [ios]
 \table 80%
     \header \li Target Platform \li Architecture \li Build Environment \li Notes
-    \row \li iOS 12, \b{iOS 13}
+    \row \li iOS 12, \b{iOS 13}, iOS 14
         \li \c armv8 (\c arm64)
-        \li \b {Xcode 11} (iOS 13.2 SDK)
+        \li Xcode \b{11 (iOS 13.2 SDK)}, Xcode 12 (iOS 14 SDK)
         \li
     \row \li tvOS 12, tvOS 13
         \li \c armv8 (\c arm64)