This was created by checking out qtdoc and checking out the kf5
patches from kde.  For more details of those, see
https://dot.kde.org/2021/04/06/announcing-kdes-qt-5-patch-collection

 from kde:
 git clone https://invent.kde.org/qt/qt/qtmultimedia
 cd qtmultimedia
 git checkout -t origin/5.15
 git format-patch origin/5.15.2..origin/kde/5.15

To update for new patches, git pull and then rerun git format-patch.

Last updated: 2021-01-25

 Following patches commented:
 patch 01 would change the version to 5.15.3
 patch 02 already applied

#From 7335d6853f753510236c3ab569788611dbcb9bef Mon Sep 17 00:00:00 2001
#From: Jani Heikkinen <jani.heikkinen@qt.io>
#Date: Tue, 27 Oct 2020 07:48:30 +0200
#Subject: [PATCH 1/3] Bump version
#
#Change-Id: Iba4de35238fedfa798b366a4e36aed63405a6583
#---
# .qmake.conf | 2 +-
# 1 file changed, 1 insertion(+), 1 deletion(-)
#
#diff --git a/.qmake.conf b/.qmake.conf
#index 1dc5dd15f..5fb75cffe 100644
#--- a/.qmake.conf
#+++ b/.qmake.conf
#@@ -2,4 +2,4 @@ load(qt_build_config)
# 
# DEFINES += QT_NO_FOREACH QT_NO_JAVA_STYLE_ITERATORS QT_NO_LINKED_LIST
# 
#-MODULE_VERSION = 5.15.2
#+MODULE_VERSION = 5.15.3
#-- 
#2.33.0
#
#From 5b4e84ed4b93f849aa9367010ddb8c00c4030f6d Mon Sep 17 00:00:00 2001
#From: Antti Kokko <antti.kokko@qt.io>
#Date: Tue, 27 Oct 2020 10:02:12 +0200
#Subject: [PATCH 2/3] Add changes file for Qt 5.15.2
#MIME-Version: 1.0
#Content-Type: text/plain; charset=UTF-8
#Content-Transfer-Encoding: 8bit
#
#- 6d70c875615ffc9c315e203530aac0d320185701 Add changes file for Qt 5.15.1
#+ fd2bb11b9c9f4a0cff99ed21d9e5291ff5ec065d AVF: Introduce QCameraCaptureDestinationControl_iid
#+ b34065e03e467d2c2b7a04e84bbec815f595220c CameraBin: unset GValues after finish using them
#+ 9862bf04d18d8453c5bf2667768c0b8fbafe512c Gstreamer: fix camerabin's supported focus point mode
#+ 67cac1524f56af09289eb76b5e2a38ca6d2a78c6 DirectShow: Use also pin category when negotiating
#+ 4b26133b1cac084a61dbbf68b3fff711ca49f712 Bump version
#+ 4ca84a8ae95d2703d2459d6335c4420ae32b37b6 Fix nullptr dereference in directshow plugin
#+ 732b1abff8eaa6ac5ff0414aea25ad7617dab2e8 Add changes file for Qt 5.12.10
#
#Change-Id: I4f45ad937938681a7a233e975ce9290ddaa84105
#Reviewed-by: Christian Strømme <christian.stromme@qt.io>
#(cherry picked from commit fd30913d4601d12437404e1d20113a1ed6364ccc)
#Reviewed-by: Qt Cherry-pick Bot <cherrypick_bot@qt-project.org>
#---
# dist/changes-5.15.2 | 29 +++++++++++++++++++++++++++++
# 1 file changed, 29 insertions(+)
# create mode 100644 dist/changes-5.15.2
#
#diff --git a/dist/changes-5.15.2 b/dist/changes-5.15.2
#new file mode 100644
#index 000000000..2dfc02bf2
#--- /dev/null
#+++ b/dist/changes-5.15.2
#@@ -0,0 +1,29 @@
#+Qt 5.15.2 is a bug-fix release. It maintains both forward and backward
#+compatibility (source and binary) with Qt 5.15.1.
#+
#+For more details, refer to the online documentation included in this
#+distribution. The documentation is also available online:
#+
#+  https://doc.qt.io/qt-5.15/index.html
#+
#+The Qt version 5.15 series is binary compatible with the 5.14.x series.
#+Applications compiled for 5.14 will continue to run with 5.15.
#+
#+Some of the changes listed in this file include issue tracking numbers
#+corresponding to tasks in the Qt Bug Tracker:
#+
#+  https://bugreports.qt.io/
#+
#+Each of these identifiers can be entered in the bug tracker to obtain more
#+information about a particular change.
#+
#+****************************************************************************
#+*                          Library                                         *
#+****************************************************************************
#+
#+AVFoundation:
#+ - [QTBUG-85470] Fixed the capture signal emission. CaptureToBuffer,
#+   and CaptureToFile will now emit imageAvailable, and imageSaved, respectively.
#+   Additionally imageCaptured will now only be emitted if there is a video
#+   frame available.
#+
#-- 
#2.33.0
#
From bd29c87027637a013f2c5e3b549fcda84e4d7545 Mon Sep 17 00:00:00 2001
From: Andy Shaw <andy.shaw@qt.io>
Date: Fri, 27 Nov 2020 11:31:43 +0100
Subject: [PATCH 3/3] Revert "Map
 QVideoFrame::Format_Y8=>QImage::Format_Grayscale8 in QVideoFrame"
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

This reverts commit 2b96c113cf7057b556856149114999b973b3f2c2, due to the
fact that it introduces a problem with existing cameras on Windows. So
reverting for now until a fix can be found.

Change-Id: Ica59c8a68de7aecf6a4ebd1bd044363e9acefd93
Reviewed-by: Liang Qi <liang.qi@qt.io>
Reviewed-by: Tor Arne Vestbø <tor.arne.vestbo@qt.io>
(cherry picked from commit 67d1ff140e60e3372d05fc7af2cf85de891a31f0)
Reviewed-by: Qt Cherry-pick Bot <cherrypick_bot@qt-project.org>
---
 src/multimedia/video/qvideoframe.cpp                         | 5 +----
 src/multimediawidgets/qpaintervideosurface.cpp               | 3 +--
 .../unit/qpaintervideosurface/tst_qpaintervideosurface.cpp   | 4 ++--
 tests/auto/unit/qvideoframe/tst_qvideoframe.cpp              | 2 +-
 4 files changed, 5 insertions(+), 9 deletions(-)

diff --git a/src/multimedia/video/qvideoframe.cpp b/src/multimedia/video/qvideoframe.cpp
index 7840eda31..fd7b74075 100644
--- a/src/multimedia/video/qvideoframe.cpp
+++ b/src/multimedia/video/qvideoframe.cpp
@@ -964,8 +964,6 @@ QVideoFrame::PixelFormat QVideoFrame::pixelFormatFromImageFormat(QImage::Format
         return Format_RGB555;
     case QImage::Format_RGB888:
         return Format_RGB24;
-    case QImage::Format_Grayscale8:
-        return Format_Y8;
     default:
         return Format_Invalid;
     }
@@ -1019,13 +1017,12 @@ QImage::Format QVideoFrame::imageFormatFromPixelFormat(PixelFormat format)
     case Format_IMC2:
     case Format_IMC3:
     case Format_IMC4:
+    case Format_Y8:
     case Format_Y16:
     case Format_Jpeg:
     case Format_CameraRaw:
     case Format_AdobeDng:
         return QImage::Format_Invalid;
-    case Format_Y8:
-        return QImage::Format_Grayscale8;
     case Format_User:
     default:
         return QImage::Format_Invalid;
diff --git a/src/multimediawidgets/qpaintervideosurface.cpp b/src/multimediawidgets/qpaintervideosurface.cpp
index 80bfec7bc..5fe76d869 100644
--- a/src/multimediawidgets/qpaintervideosurface.cpp
+++ b/src/multimediawidgets/qpaintervideosurface.cpp
@@ -109,8 +109,7 @@ QVideoSurfaceGenericPainter::QVideoSurfaceGenericPainter()
         m_imagePixelFormats << QVideoFrame::Format_RGB24;
 
      m_imagePixelFormats << QVideoFrame::Format_ARGB32
-                         << QVideoFrame::Format_RGB565
-                         << QVideoFrame::Format_Y8;
+                         << QVideoFrame::Format_RGB565;
 }
 
 QList<QVideoFrame::PixelFormat> QVideoSurfaceGenericPainter::supportedPixelFormats(
diff --git a/tests/auto/unit/qpaintervideosurface/tst_qpaintervideosurface.cpp b/tests/auto/unit/qpaintervideosurface/tst_qpaintervideosurface.cpp
index 98ec5fc06..be5c85ab9 100644
--- a/tests/auto/unit/qpaintervideosurface/tst_qpaintervideosurface.cpp
+++ b/tests/auto/unit/qpaintervideosurface/tst_qpaintervideosurface.cpp
@@ -253,8 +253,8 @@ void tst_QPainterVideoSurface::supportedFormat_data()
             << QAbstractVideoBuffer::NoHandle
             << QVideoFrame::Format_Y8
             << QSize(640, 480)
-            << true
-            << true;
+            << false
+            << false;
     QTest::newRow("Texture: rgb32 640x480")
             << QAbstractVideoBuffer::GLTextureHandle
             << QVideoFrame::Format_RGB32
diff --git a/tests/auto/unit/qvideoframe/tst_qvideoframe.cpp b/tests/auto/unit/qvideoframe/tst_qvideoframe.cpp
index e99c4bf77..402ddf334 100644
--- a/tests/auto/unit/qvideoframe/tst_qvideoframe.cpp
+++ b/tests/auto/unit/qvideoframe/tst_qvideoframe.cpp
@@ -978,7 +978,7 @@ void tst_QVideoFrame::formatConversion_data()
             << QImage::Format_Invalid
             << QVideoFrame::Format_IMC4;
     QTest::newRow("QVideoFrame::Format_Y8")
-            << QImage::Format_Grayscale8
+            << QImage::Format_Invalid
             << QVideoFrame::Format_Y8;
     QTest::newRow("QVideoFrame::Format_Y16")
             << QImage::Format_Invalid
-- 
2.33.0