This was created by checking out qtquickcontrols and checking out the kf5
patches from kde.  For more details of those, see
https://dot.kde.org/2021/04/06/announcing-kdes-qt-5-patch-collection

from kde:
 git clone https://invent.kde.org/qt/qt/qtquickcontrols
 cd qtwayland
 git checkout -t origin/5.15
 git format-patch origin/5.15.2..origin/kde/5.15

To update for new patches, git pull and then rerun git format-patch.

Last updated: 2021-01-25

Following patches commented:
0001-Bump-version.patch  not wanted
0002-Add-changes-file-for-Qt-5.15.2.patch  already applied

#From c8a0b90ca6f42610573c477a6350d27d09464e76 Mon Sep 17 00:00:00 2001
#From: Jani Heikkinen <jani.heikkinen@qt.io>
#Date: Tue, 27 Oct 2020 07:49:04 +0200
#Subject: [PATCH 1/3] Bump version
#
#Change-Id: Ied32e96eb5c30e662215001ba1277603445fdcd1
#---
# .qmake.conf | 2 +-
# 1 file changed, 1 insertion(+), 1 deletion(-)
#
#diff --git a/.qmake.conf b/.qmake.conf
#index f3d7c57e..e708466f 100644
#--- a/.qmake.conf
#+++ b/.qmake.conf
#@@ -4,4 +4,4 @@ android|ios|qnx|isEmpty(QT.widgets.name): CONFIG += no_desktop
# 
# DEFINES += QT_NO_FOREACH QT_NO_JAVA_STYLE_ITERATORS QT_NO_LINKED_LIST
# 
#-MODULE_VERSION = 5.15.2
#+MODULE_VERSION = 5.15.3
#-- 
#2.33.0

#From daedf29891225170d9bf4be182231ab399bba5a1 Mon Sep 17 00:00:00 2001
#From: Antti Kokko <antti.kokko@qt.io>
#Date: Tue, 27 Oct 2020 10:02:11 +0200
#Subject: [PATCH 2/3] Add changes file for Qt 5.15.2
#
#- e82f39989e80dc541b6ad2bfa2ff6ca4679d1bf1 Add changes file for Qt 5.15.1
#+ f20d5ba29e97b96c9aba39649b853a736986582a Bump version
#+ fc0bbf8a78c19a71287c5f37a23d74b723fb35c0 Remove reference to an attached Accessible object for QtObject type
#+ 8b05eb5e00051cadadd392ab3e731079fcd3d2fa Add changes file for Qt 5.12.10
#
#Change-Id: Id496cc8d678ca6ff868a604a26bc8982b48e583b
#Reviewed-by: Mitch Curtis <mitch.curtis@qt.io>
#(cherry picked from commit 7c29283041a50def3ceca7de4471f211c9b30d4e)
#Reviewed-by: Qt Cherry-pick Bot <cherrypick_bot@qt-project.org>
#---
# dist/changes-5.15.2 | 25 +++++++++++++++++++++++++
# 1 file changed, 25 insertions(+)
# create mode 100644 dist/changes-5.15.2
#
#diff --git a/dist/changes-5.15.2 b/dist/changes-5.15.2
#new file mode 100644
#index 00000000..0aac9b73
#--- /dev/null
#+++ b/dist/changes-5.15.2
#@@ -0,0 +1,25 @@
#+Qt 5.15.2 is a bug-fix release. It maintains both forward and backward
#+compatibility (source and binary) with Qt 5.15.1.
#+
#+For more details, refer to the online documentation included in this
#+distribution. The documentation is also available online:
#+
#+  https://doc.qt.io/qt-5.15/index.html
#+
#+The Qt version 5.15 series is binary compatible with the 5.14.x series.
#+Applications compiled for 5.14 will continue to run with 5.15.
#+
#+Some of the changes listed in this file include issue tracking numbers
#+corresponding to tasks in the Qt Bug Tracker:
#+
#+  https://bugreports.qt.io/
#+
#+Each of these identifiers can be entered in the bug tracker to obtain more
#+information about a particular change.
#+
#+****************************************************************************
#+*                          Controls                                        *
#+****************************************************************************
#+
#+ - [QTBUG-86315] Fixed warning messages for Accessible, TableViewColumn.
#+
#-- 
#2.33.0

From cf3f6d7fec824cdf01f9b329ab3b92b1c0e0a420 Mon Sep 17 00:00:00 2001
From: Andy Shaw <andy.shaw@qt.io>
Date: Fri, 6 Nov 2020 12:12:56 +0100
Subject: [PATCH 3/3] Convert the path to a url correctly

Just adding file:// is not enough if it is a Windows file path as it
will cause it to lose the drive information as a result. So use the
function available to get this correctly.

Change-Id: I9927a8a67b1743c24cd317bea9ebf5e174b77604
Reviewed-by: Mitch Curtis <mitch.curtis@qt.io>
---
 src/dialogs/DefaultFileDialog.qml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/src/dialogs/DefaultFileDialog.qml b/src/dialogs/DefaultFileDialog.qml
index 077b5acd..ea2fa42d 100644
--- a/src/dialogs/DefaultFileDialog.qml
+++ b/src/dialogs/DefaultFileDialog.qml
@@ -115,7 +115,7 @@ AbstractFileDialog {
 
     function dirDown(path) {
         view.selection.clear()
-        root.folder = "file://" + path
+        root.folder = root.pathToUrl(path)
     }
     function dirUp() {
         view.selection.clear()
-- 
2.33.0